---
title: "Resources"
weight: 13
description: "Additional resources to learn about Tetragon"
---

### Conference talks

| Title | Authors | Conference | Date |
| ----- | ------- | ---------- | ---- |
| [eBPF-based, Kubernetes-native: observability & security with Tetragon](https://www.youtube.com/watch?v=xqKp6GfMuic)                                                     | Anna Kapuścińska    | TechSpot                                         | 2024 |
| [Past, Present, Future of Tetragon- First Production Use Cases, Lessons Learnt, Where Are We Heading? ](https://youtu.be/2BIe4VmSYyQ)                        | John Fastabend & Natália Réka Ivánkó | KubeCon EU                                        | 2023 |
| [eBPF and Kubernetes — Better Together! Observability and Security with Tetragon](https://youtu.be/oU7dPKoVfm4)                                              | Anna Kapuścińska & James Laverack    | Kubernetes Community Days UK                      | 2023 |
| [The Next Log4jshell?! Preparing for CVEs with eBPF!](https://youtu.be/u8HKg5pENj4)                                                                          | John Fastabend & Natália Réka Ivánkó | KubeCon EU                                        | 2023 |
| [Tutorial: Getting Familiar with Security Observability Using eBPF & Cilium Tetragon](https://youtu.be/kTGU-Nc2Db0)                                          | Duffie Cooley & Raphaël Pinson       | KubeCon EU                                        | 2023 |
| [Securing the Superpowers: Who Loaded That eBPF Program?](https://www.youtube.com/watch?v=UBVTJ0LeXxc)                                                       | John Fastabend & Natália Réka Ivánkó | Cloud Native SecurityCon NA                        | 2023 |
| [Container Security and Runtime Enforcement with Tetragon](https://www.youtube.com/watch?v=fw40ROmswbM)                                                      | Djalal Harouni                       | eBPF Summit                                       | 2022 |
| [You and Your Security Profiles; Generating Security Policies with the Help of eBPF](https://www.youtube.com/watch?v=EhQI1qPVb0E)                            | John Fastabend & Natália Réka Ivánkó | eBPF Day North America                            | 2022 |
| [eBPF for Runtime Security](https://www.youtube.com/watch?v=maP3ceTjugk)                                                                                     | Liz Rice                             | ContainerDays                            | 2022 |
| [Real Time Security - eBPF for Preventing attacks](https://www.youtube.com/watch?v=Xs3MBK17kCk)                                                              | Liz Rice                             | Cloud Native SecurityCon EU                           | 2022 |
| [Keeping your cluster safe from attacks with eBPF](https://www.youtube.com/watch?v=agN68U8x1go)                                                              | Jed Salazar & Natália Réka Ivánkó    | eBPF Summit                                       | 2021 |
| [Uncovering a Sophisticated Kubernetes Attack in Real Time Part II.](https://www.oreilly.com/library/view/infrastructure-ops/0636920625377/video335775.html) | Jed Salazar & Natália Réka Ivánkó    | O'Reilly Superstream Series, Infrastructure & Ops | 2021 |
| [Uncovering a Sophisticated Kubernetes Attack in Real-Time](https://www.youtube.com/watch?v=bohnofE_dvw)                                                     | Jed Salazar & Natália Réka Ivánkó    | KubeCon EU                                        | 2020 |

### Book

[Security Observability with eBPF](https://isovalent.com/ebpf-security/) - Jed Salazar & Natália Réka Ivánkó, OReilly, 2022

### Blog posts

[Tetragon 1.0: Kubernetes Security Observability & Runtime Enforcement with eBPF](https://isovalent.com/blog/post/tetragon-release-10/) - Thomas Graf, 2023

[Tutorial: Setting Up a Cybersecurity Honeypot with Tetragon to Trigger Canary Tokens](https://isovalent.com/blog/post/tetragon-canary-tokens-tutorial/) - Dean Lewis, 2023

[Can I use Tetragon without Cilium?](https://isovalent.com/blog/post/can-i-use-tetragon-without-cilium-yes/) - Dean Lewis, 2023

[Detecting a Container Escape with Cilium and eBPF](https://isovalent.com/blog/post/2021-11-container-escape) - Natália Réka Ivánkó, 2021

[Detecting and Blocking log4shell with Isovalent Cilium Enterprise](https://isovalent.com/blog/post/2021-12-log4shell) - Jed Salazar, 2021

### Hands-on lab

[Getting Started with Tetragon](https://isovalent.com/labs/tetragon-getting-started/) - Natália Réka Ivánkó, Roland Wolters, Raphaël Pinson

[Exploring Tetragon - A Security Observability Tool for Kubernetes, Docker, and Linux](https://labs.iximiuz.com/tutorials/introduction-to-tetragon) - Ivan Velichko

### Video Tutorials

[eBPF for Runtime Enforcement | Tetragon Introduction and Overview](https://www.youtube.com/watch?v=MObLmvBeu00) - Rawkode Academy

[Restrict Access to Secure Files with Tetragon | eBPF Runtime Enforcement](https://www.youtube.com/watch?v=SiQm6N3ucyc) - Rawkode Academy
