// SPDX-License-Identifier: Apache-2.0
// Copyright Authors of Tetragon

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	context "context"

	ciliumiov1alpha1 "github.com/cilium/tetragon/pkg/k8s/apis/cilium.io/v1alpha1"
	scheme "github.com/cilium/tetragon/pkg/k8s/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// PodInfoGetter has a method to return a PodInfoInterface.
// A group's client should implement this interface.
type PodInfoGetter interface {
	PodInfo(namespace string) PodInfoInterface
}

// PodInfoInterface has methods to work with PodInfo resources.
type PodInfoInterface interface {
	Create(ctx context.Context, podInfo *ciliumiov1alpha1.PodInfo, opts v1.CreateOptions) (*ciliumiov1alpha1.PodInfo, error)
	Update(ctx context.Context, podInfo *ciliumiov1alpha1.PodInfo, opts v1.UpdateOptions) (*ciliumiov1alpha1.PodInfo, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, podInfo *ciliumiov1alpha1.PodInfo, opts v1.UpdateOptions) (*ciliumiov1alpha1.PodInfo, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*ciliumiov1alpha1.PodInfo, error)
	List(ctx context.Context, opts v1.ListOptions) (*ciliumiov1alpha1.PodInfoList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *ciliumiov1alpha1.PodInfo, err error)
	PodInfoExpansion
}

// podInfo implements PodInfoInterface
type podInfo struct {
	*gentype.ClientWithList[*ciliumiov1alpha1.PodInfo, *ciliumiov1alpha1.PodInfoList]
}

// newPodInfo returns a PodInfo
func newPodInfo(c *CiliumV1alpha1Client, namespace string) *podInfo {
	return &podInfo{
		gentype.NewClientWithList[*ciliumiov1alpha1.PodInfo, *ciliumiov1alpha1.PodInfoList](
			"podinfo",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *ciliumiov1alpha1.PodInfo { return &ciliumiov1alpha1.PodInfo{} },
			func() *ciliumiov1alpha1.PodInfoList { return &ciliumiov1alpha1.PodInfoList{} },
		),
	}
}
