// SPDX-License-Identifier: Apache-2.0
// Copyright Authors of Tetragon

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	internalinterfaces "github.com/cilium/tetragon/pkg/k8s/client/informers/externalversions/internalinterfaces"
)

// Interface provides access to all the informers in this group version.
type Interface interface {
	// PodInfo returns a PodInfoInformer.
	PodInfo() PodInfoInformer
	// TracingPolicies returns a TracingPolicyInformer.
	TracingPolicies() TracingPolicyInformer
	// TracingPoliciesNamespaced returns a TracingPolicyNamespacedInformer.
	TracingPoliciesNamespaced() TracingPolicyNamespacedInformer
}

type version struct {
	factory          internalinterfaces.SharedInformerFactory
	namespace        string
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// New returns a new Interface.
func New(f internalinterfaces.SharedInformerFactory, namespace string, tweakListOptions internalinterfaces.TweakListOptionsFunc) Interface {
	return &version{factory: f, namespace: namespace, tweakListOptions: tweakListOptions}
}

// PodInfo returns a PodInfoInformer.
func (v *version) PodInfo() PodInfoInformer {
	return &podInfoInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// TracingPolicies returns a TracingPolicyInformer.
func (v *version) TracingPolicies() TracingPolicyInformer {
	return &tracingPolicyInformer{factory: v.factory, tweakListOptions: v.tweakListOptions}
}

// TracingPoliciesNamespaced returns a TracingPolicyNamespacedInformer.
func (v *version) TracingPoliciesNamespaced() TracingPolicyNamespacedInformer {
	return &tracingPolicyNamespacedInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}
